
Drupal.behaviors.pixlr = function(context) {
  $('.pixlr-filepath', context).each(
    function(index) {
      var key = $(this).attr('id').replace(/^edit-(.*)-pixlr-filepath$/, '$1').replace(/-/g, '_');
      var obj = new Array();
      obj[key] = {filepath: $(this).attr('value'), url: Drupal.settings.pixlr.base_url + '/' + $(this).attr('value')};
      $.extend(true, Drupal.settings.pixlr, obj);
    }
  );
  
  $('div.imagefield-preview', context).each(
    function(index) {
      var id = $(this).parent().parent().parent().attr('id');
      var field_name = id.replace(/^edit-(.*)-.*-upload-wrapper$/, '$1');
      var delta = id.replace('edit-' + field_name + '-', '').replace(/^(.*)-upload-wrapper$/, '$1');
      field_name = field_name.replace(/-/g, '_');
      if (typeof(Drupal.settings.pixlr[field_name]) !== 'undefined') {
        if (Drupal.settings.pixlr[field_name]['pixlr_editor'] || Drupal.settings.pixlr[field_name]['pixlr_express']) {
          var html = '<div class="pixlr pixlr-existing">';
          html += '<input type="hidden" class="field-name" value="' + field_name + '">';
          html += '<input type="hidden" class="delta" value="' + delta + '">';
          if (Drupal.settings.pixlr[field_name]['pixlr_editor']) {
            html += '<div class="editor">' + Drupal.t('Pixlr Editor') + '</div>';
          }
          if (Drupal.settings.pixlr[field_name]['pixlr_express']) {
            html += '<div class="express">' + Drupal.t('Pixlr Express') + '</div>';
          }
          if (Drupal.settings.pixlr[field_name]['upload']) {
            html += '<div class="upload">' + Drupal.t('Pixlr Upload') + '</div>';
          }
          html += '</div>';
          $(this).find('img').after(html);
        }
      }
    }
  );
  
  $('div.filefield-upload', context).each(
    function(index) {
      var id = $(this).parent().parent().parent().parent().attr('id');
      var field_name = id.replace(/^edit-(.*)-.*-upload-wrapper$/, '$1');
      var delta = id.replace('edit-' + field_name + '-', '').replace(/^(.*)-upload-wrapper$/, '$1');
      field_name = field_name.replace(/-/g, '_');
      if (typeof(Drupal.settings.pixlr[field_name]) !== 'undefined') {
        if (Drupal.settings.pixlr[field_name]['pixlr_editor'] || Drupal.settings.pixlr[field_name]['pixlr_express']) {
          var html = '<div class="pixlr pixlr-new">';
          html += '<input type="hidden" class="field-name" value="' + field_name + '">';
          html += '<input type="hidden" class="delta" value="' + delta + '">';
          if (Drupal.settings.pixlr[field_name]['pixlr_editor']) {
            html += '<div class="editor">' + Drupal.t('Pixlr Editor') + '</div>';
          }
          if (Drupal.settings.pixlr[field_name]['pixlr_express']) {
            html += '<div class="express">' + Drupal.t('Pixlr Express') + '</div>';
          }
          html += '</div>';
          $(this).before(html);
        }
      }
    }
  );
  
  var $pixlr_divs = $('.pixlr', context);
  $pixlr_divs.css({'background-image': 'url(\'' + Drupal.settings.basePath + Drupal.settings.pixlr.background + '\')'});
  $pixlr_divs.find('div').css({'background-image': 'url(\'' + Drupal.settings.basePath + Drupal.settings.pixlr.icon + '\')', 'background-repeat': 'no-repeat', 'background-position': '2px 2px'}).hover(
    function() {
      $(this).css({'background-color': 'black'});
    },
    function() {
      $(this).css({'background-color': 'transparent'});
    }
  );
  
  var $pixlr_divs_existing = $('.pixlr.pixlr-existing', context);
  $pixlr_divs_existing.css({'position': 'absolute'}).hide();
  $pixlr_divs_existing.find('div.editor, div.express').click(
    function() {
      var field_name = $(this).parent().find('.field-name').attr('value');
      var delta = $(this).parent().find('.delta').attr('value');
      pixlr.overlay.show({
        'service': $(this).attr('class'),
        'image': Drupal.settings.pixlr[field_name + '_' + delta]['url'],
        'target': Drupal.settings.pixlr.target + field_name + '/' + delta + '/0/' + Drupal.settings.pixlr[field_name]['replace'] + '/1',
        'exit': Drupal.settings.pixlr.exit,
        'loc': Drupal.settings.pixlr.loc,
        'referrer': Drupal.settings.pixlr.referrer,
        'credentials': Drupal.settings.pixlr.credentials
      });
    }
  );
  $pixlr_divs_existing.find('div.upload').click(
    function() {
      var field_name = $(this).parent().find('.field-name').attr('value');
      var delta = $(this).parent().find('.delta').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.pixlr.upload,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': Drupal.settings.pixlr[field_name + '_' + delta]['filepath']},
        success: function (data) {Drupal.settings.pixlr[field_name + '_' + delta]['url'] = data;},
        error: function (msg) {alert("Failed uploading to Pixlr: " + msg);}
      });
    }
  );
  $('div.imagefield-preview', context).css('position', 'relative').hover(
    function() {
      $(this).find('.pixlr').show();
    },
    function() {
      $(this).find('.pixlr').hide();
    }
  );
  
  var $pixlr_divs_new = $('.pixlr.pixlr-new', context);
  $pixlr_divs_new.find('div.editor, div.express').click(
    function() {
      var field_name = $(this).parent().find('.field-name').attr('value');
      var delta = $(this).parent().find('.delta').attr('value');
      pixlr.overlay.show({
        'service': $(this).attr('class'),
        'target': Drupal.settings.pixlr.target + field_name + '/' + delta + '/1/' + Drupal.settings.pixlr[field_name]['replace'] + '/1',
        'exit': Drupal.settings.pixlr.exit,
        'loc': Drupal.settings.pixlr.loc,
        'referrer': Drupal.settings.pixlr.referrer,
        'credentials': Drupal.settings.pixlr.credentials
      });
    }
  );
}
